##################################################################
##*****************************************************************
##* Copyright (C) 1998 Sylvio Triebel
##*
##* Id           : $Id: alter.tcl,v 1.4 1998/01/28 16:33:56 silvio Exp $
##* Revision     : $Revision: 1.4 $
##* Datum        : 16.1.98
##* Systems      : Tcl/Tk 7.6 8.0, [incr tcl] 
##*
##*
##* Documentation: 
##*
##*****************************************************************

#*********************** Alter ****************************************

proc tkdrawBindAlter { canvas } {
    global tkdraw tkdraw_alter_map

    set tkdraw(canvas) $canvas

    tkdrawDeselectAll
    catch { unset tkdraw_alter_map }

    #alle alten bindings loeschen
    tkdrawInitCanvasBindings

    bind $tkdraw(canvas) <ButtonPress-1> { 
	set tkdraw(oldx) [$tkdraw(canvas) canvasx %x $tkdraw(raster)]
	set tkdraw(oldy) [$tkdraw(canvas) canvasy %y $tkdraw(raster)]

	set id [$tkdraw(canvas) find closest $tkdraw(oldx) $tkdraw(oldy)]
	if { [tkdrawIsItem $id] == 1 } {
	    tkdrawDrawHandles $id
	}
    }

    set id [lindex $tkdraw(lastselected) 0]
    if { [tkdrawIsItem $id] == 1 } {
	tkdrawDrawHandles $id
    }
}

proc tkdrawBindAlterDestructor { canvas } {
    global tkdraw tkdraw_alter_map
    catch { unset tkdraw_alter_map }
    $canvas delete withtag handle
    $canvas dtag reshape reshape
    $canvas dtag selected selected
}

proc tkdrawDrawHandles { id } {
    global tkdraw tkdraw_alter_map tk_version

    catch { $tkdraw(canvas) dtag selected selected }
    catch { $tkdraw(canvas) dtag reshape reshape }
#     puts "$tkdraw(canvas) addtag reshape withtag $id"
    $tkdraw(canvas) addtag reshape withtag $id
    $tkdraw(canvas) addtag selected withtag $id
    if { [tkdrawIsBgItem $id] } {
# 	puts "$tkdraw(canvas) addtag reshape above $id"
# 	$tkdraw(canvas) addtag reshape above $id
# 	$tkdraw(canvas) addtag selected above $id
	$tkdraw(canvas) addtag reshape withtag [expr $id+1]
	$tkdraw(canvas) addtag selected withtag [expr $id+1]
    } else {
# 	puts "$tkdraw(canvas) addtag reshape below $id"
# 	$tkdraw(canvas) addtag reshape below $id
# 	$tkdraw(canvas) addtag selected below $id
	$tkdraw(canvas) addtag reshape withtag [expr $id-1]
	$tkdraw(canvas) addtag selected withtag [expr $id-1]
    }
#     puts "original Resiobj: [$tkdraw(canvas) find withtag reshape]"
#     puts "vor binding Resiobj: [$tkdraw(canvas) find withtag reshape]"
    set hsize 2

    set groups [tkdrawGetGroups $id]
	
    if { $groups == "" } {
	$tkdraw(canvas) delete withtag handle
	set coords [$tkdraw(canvas) coords $id]

	set    tkdraw(alter_undo) "$tkdraw(canvas) coords $id $coords;"
	append tkdraw(alter_undo) "$tkdraw(canvas) coords [expr $id-1] $coords;"
	append tkdraw(alter_undo) "tkdrawDrawHandles $id"


	set limit [llength $coords]

	if { $tk_version != "8.0" } {
	    if { [$tkdraw(canvas) type $id] == "polygon" } {
		set limit [expr [llength $coords]-2]
	    }
	}

	for {set i 0} {$i < $limit} {incr i 2} {
	    set x [lindex $coords $i]
	    set y [lindex $coords [expr $i+1]]

	    set h [$tkdraw(canvas) create rectangle \
		    [expr $x-$hsize] [expr $y-$hsize] \
		    [expr $x+$hsize] [expr $y+$hsize] \
		    -fill black -tags handle]

	    set tkdraw_alter_map($h) [list $id $i]

	    set tkdraw(moveactiv) 0
	    $tkdraw(canvas) bind $h <ButtonPress-1> { 
		set tkdraw(undo) $tkdraw(alter_undo)
		set tkdraw(oldx) [$tkdraw(canvas) canvasx %x $tkdraw(raster)]
		set tkdraw(oldy) [$tkdraw(canvas) canvasy %y $tkdraw(raster)]
		set tkdraw(moveactiv) 1
	    }
	    $tkdraw(canvas) bind $h <ButtonRelease-1> { 
		set tkdraw(moveactiv) 0
	    }
	    $tkdraw(canvas) bind $h <Motion> {
		if { $tkdraw(moveactiv) } {
		    set newx [$tkdraw(canvas) canvasx %x $tkdraw(raster)] 
		    set newy [$tkdraw(canvas) canvasy %y $tkdraw(raster)]
		    set dx [expr $newx - $tkdraw(oldx)]
		    set dy [expr $newy - $tkdraw(oldy)]
		    set tkdraw(oldx) $newx
		    set tkdraw(oldy) $newy
		    set cur [$tkdraw(canvas) find withtag current] 
		    $tkdraw(canvas) move $cur $dx $dy
		    tkdrawUpdateCoords $cur $newx $newy
		}
	    }
	}
    }
}

proc tkdrawUpdateCoords { h x y } {
    global tkdraw tkdraw_alter_map tk_version

    set odesc $tkdraw_alter_map($h)
    set obj [lindex $odesc 0]
#     puts "Refobj $obj / $odesc"
    set idx [lindex $odesc 1]
    set coords [$tkdraw(canvas) coords $obj]
#     puts "alte Koordinaten $coords"
    set coords [lreplace $coords $idx [expr $idx+1] $x $y]

    if { $tk_version != "8.0" } {
	if { [$tkdraw(canvas) type $obj] == "polygon" } {
	    set coords [lrange $coords 0 [expr [llength $coords]-3]]
	} 
    }
#     puts "Resiobj: [$tkdraw(canvas) find withtag reshape]"
    foreach obj [$tkdraw(canvas) find withtag reshape] {
# 	puts $obj
	eval $tkdraw(canvas) coords $obj $coords
    }
#     puts "neue Koordinaten $coords"
}

