##################################################################
##*****************************************************************
##* Copyright (C) 1998 Sylvio Triebel
##*
##* Id           : $Id: clipart.tcl,v 1.3 1998/01/16 12:54:52 silvio Exp $
##* Revision     : $Revision: 1.3 $
##* Datum        : 16.1.98
##* Systems      : Tcl/Tk 7.6 8.0, [incr tcl] 
##*
##*
##* Documentation: 
##*
##*****************************************************************


proc tkdrawOpenClipart { name filename } {
    global tkdraw

    set b [ button $tkdraw(LeftToolbar).clp$name \
		-text $name -relief sunken \
		-command "tkdrawOpenClipartBrowser $filename"
	    ]

    pack $b
    
}

proc tkdrawOpenClipartBrowser { filename } {
    global tkdraw

    set f .clip

    catch { destroy $f }

    toplevel .clip
    wm title $f "Clipart"
    wm iconname $f "Clipart"
#     wm geometry $w 400x400

    #******************** BUTTON Bereich **************************

    set b $f.buttfrm
    frame $b -relief raised -bd 2
#     pack $b -side right
    grid $b -row 0 -column 2  -sticky ns

#     button $b.copy -text Copy -width 10 -command tkdrawCopySelected
#     pack $b.copy -pady 0.1c

    button $b.paste -text Copy/Paste -width 10 -command {
	tkdrawCopySelected
	set tkdraw(canvas) $tkdraw(c)
	tkdrawPaste
	set tkdraw(canvas) $tkdraw(clipart)

# 	set tkdraw(canvas) .clip.buttfrm.cvs
# 	tkdrawPaste
# 	set tkdraw(canvas) $tkdraw(clipart)
    }
    pack $b.paste -pady 0.1c

    button $b.cancel -text Cancel -width 10 -command "destroy $f"
    pack $b.cancel -pady 0.1c

    canvas $b.cvs -width 80 -height 80 -background white
    pack $b.cvs -pady 0.5c -padx 0.5c

    #******************** CANVAS Bereich **************************

    set tkdraw(clipart) $f.cvs

    scrollbar $f.hscroll -orient horiz -command "$tkdraw(clipart) xview"
    scrollbar $f.vscroll -command "$tkdraw(clipart) yview"
    pack $tkdraw(r).vscroll -side right -fill y

    set tkdraw(clipartWidth)  800
    set tkdraw(clipartHeight) 800
 
    canvas $tkdraw(clipart) -relief sunken -borderwidth 2 \
	-scrollregion "0 0 $tkdraw(clipartWidth) $tkdraw(clipartHeight)" \
	-background white \
	-xscrollcommand "$f.hscroll set" \
	-yscrollcommand "$f.vscroll set"

    grid $f.hscroll -row 1 -column 0 -sticky we
    grid $f.vscroll -row 0 -column 1 -sticky ns
    grid $tkdraw(clipart) -row 0 -column 0

    tkwait visibility $tkdraw(clipart)
    after 1000

    tkdrawParseClipart $filename

    bind $tkdraw(clipart) <Enter> {
	set tkdraw(canvas) $tkdraw(clipart)
	tkdrawBindEditmode select $tkdraw(clipart)
    }

    tkdrawBindEditmode select $tkdraw(clipart)
}

proc tkdrawParseClipart { filename } {
    global tkdraw

    set file [open $tkdraw(CLIPART)/$filename r]

    #zur sicherheit
    tkdrawResetGroupMap

    while { ![eof $file] } {
	gets $file line

	catch {
	    set first [lindex $line 0]
	    switch -exact $first {
		"%item" {
		    #substitude full pathnames in -stipple
		    set idx [expr [lsearch $line "-stipple" ] + 1 ]
		    if { $idx > 0 } {
			set fname [ tkdrawBmFullname [lindex $line $idx] ]
			set line [lreplace $line $idx $idx $fname]
		    }

		    tkdrawStringToItem $line 0 $tkdraw(clipart)
		}
	    }
	}
    }
    close $file

    #reset groupmap after each import procedure!
    tkdrawResetGroupMap
}
