
set tkdraw_cmdcvscnt 0

proc tkdrawCreateCmdCanvas { filename parent {packopt "" } {cvsopt ""} } {
    global tkdraw tkdraw_cmdcvscnt

    set canvas [eval canvas $parent.c$tkdraw_cmdcvscnt $cvsopt -width 61 -height 101]
    incr tkdraw_cmdcvscnt

    tkdrawParseCanvas $filename $canvas

    set bbox [$canvas bbox all]
#     puts "bbox: $bbox"
    $canvas configure -width  [lindex $bbox 2]
    $canvas configure -height [lindex $bbox 3]
    
    bind $canvas <Enter> "set tkdraw(canvasButton) $canvas"

    bind $canvas <ButtonPress-1> {
	set id [$tkdraw(canvasButton) find withtag current]
	if { $id != "" } {
	    set tags [$tkdraw(canvasButton) gettags $id]
	    set idx [expr [lsearch $tags cmd]+1]
	    set cmd [lindex $tags $idx]
	    if { $idx && $cmd != "" } {
		eval $cmd
	    }
	}
    }

    eval pack $canvas $packopt

    return $canvas
}

proc tkdrawParseCanvas { filename canvas } {
    global tkdraw

    set file [open $tkdraw(BITMAP)/$filename r]

    #zur sicherheit
    tkdrawResetGroupMap

    while { ![eof $file] } {
	gets $file line

	catch {
	    set first [lindex $line 0]
	    switch -exact $first {
		"%item" {
		    #substitude full pathnames in -stipple
		    set idx [expr [lsearch $line "-stipple" ] + 1 ]
		    if { $idx > 0 } {
			set fname [ tkdrawBmFullname [lindex $line $idx] ]
			set line [lreplace $line $idx $idx $fname]
		    }

		    tkdrawStringToItem $line 0 $canvas
		}
	    }
	}
    }
    close $file

    #reset groupmap after each import procedure!
    tkdrawResetGroupMap
}
