##################################################################
##*****************************************************************
##* Copyright (C) 1998 Sylvio Triebel
##*
##* Id           : $Id: grid.tcl,v 1.2 1998/01/16 12:54:52 silvio Exp $
##* Revision     : $Revision: 1.2 $
##* Datum        : 16.1.98
##* Systems      : Tcl/Tk 7.6 8.0, [incr tcl] 
##*
##*
##* Documentation: 
##*
##*****************************************************************


proc tkdrawDragXCanvas { a b {c ""} } {
    global tkdraw

    eval $tkdraw(c) xview $a $b $c
    tkdrawDragGrid
}

proc tkdrawDragYCanvas { a b {c ""} } {
    global tkdraw

    eval $tkdraw(c) yview $a $b $c
    tkdrawDragGrid
}

proc tkdrawDragGrid { } {
    global tkdraw

    if { $tkdraw(grid) } {
	set xa [expr [$tkdraw(c) canvasx 0]]
	set ya [expr [$tkdraw(c) canvasy 0]]

	#snap to grid
	if { $tkdraw(raster) >= 20 } {
	    set r $tkdraw(raster)
	} else {
	    set r [expr 10*$tkdraw(raster)]
	}
	set xa [expr int($xa/$r)*$r]
	set ya [expr int($ya/$r)*$r]
    
	$tkdraw(c) coords $tkdraw(grid) $xa $ya
    }
}

proc tkdrawRedrawGrid { } {
    global tkdraw tkdrawGridImage

#     puts "redraw grid"
    catch { $tkdraw(c) delete $tkdraw(grid)  }
    
    if { $tkdraw(showgrid) && $tkdraw(gravity) } {
	
# 	set raster [expr int($tkdraw(raster))]
# 	set imageName tkdrGrid$raster

# 	if { [info exist tkdrawGridImage($raster)] } {
# 	    set image $tkdrawGridImage($raster)
# 	} else {
# 	    set gridfile $tkdraw(LIB)/cache/$imageName.gif

# 	    if { [file exist $gridfile] } {
# 		#gridImage aus file laden
# 		image create photo $imageName -file $gridfile
# 	    } else {
# 		#grid muss berechnet werden ... sehr zeitaufwendig
# 		tkdrawComputeGrid $imageName

# 		#image abspeichern
# 		$imageName write $gridfile
# 		# Files werden riesig, ich war hier etwas naiv
# 	    }
# 	    set tkdrawGridImage($raster) $imageName
# 	}

        #tkdrawGrid wurde in tkdraw.tcl definiert
        set imageName tkdrawGrid
        $imageName blank
        tkdrawComputeGrid $imageName

	#find windows coords
	set w [winfo width $tkdraw(c)]
	set h [winfo height $tkdraw(c)]
	set xa [expr [$tkdraw(c) canvasx 0]]
	set xe [expr [$tkdraw(c) canvasx $w]]
	set ya [expr [$tkdraw(c) canvasy 0]]
	set ye [expr [$tkdraw(c) canvasy $h]]

	#snap to grid
	set xa [expr int($xa/$tkdraw(raster))*$tkdraw(raster)]
	set ya [expr int($ya/$tkdraw(raster))*$tkdraw(raster)]
	
	set tkdraw(grid) [$tkdraw(c) create image $xa $ya \
		-image $imageName -anchor nw ]

    } else {
        tkdrawGrid blank
	set tkdraw(grid) 0
    }

}

proc tkdrawComputeGrid { imageName } {
    global tkdraw

    #find windows coords
    set w [winfo width $tkdraw(c)]
    set h [winfo height $tkdraw(c)]
    set xa [expr [$tkdraw(c) canvasx 0]]
    set xe [expr [$tkdraw(c) canvasx $w]]
    set ya [expr [$tkdraw(c) canvasy 0]]
    set ye [expr [$tkdraw(c) canvasy $h]]
    set raster [expr int($tkdraw(raster))]

    #snap to grid
    set xa [expr int($xa/$raster)*$raster]
    set ya [expr int($ya/$raster)*$raster]
    
#     set tkdraw(grid) [$tkdraw(c) create image $xa $ya \
# 	    -image tdGrd -anchor nw ]

    #erstmal ein grobes grid bauen
    set r [expr int($raster)]
    if { $raster < 10 } { set r [expr 2*$raster] }
    if { $raster < 5  } { set r [expr 5*$raster] }
    set R [expr int(10*$raster)]

    #snap to grid
    set x0 [expr int($xa/$R)*$R - $xa]
    set y0 [expr int($ya/$R)*$R - $ya]
    set x1 [expr $xe-$xa+$R]
    set y1 [expr $ye-$ya+$R]

    set Ye [expr $ye-$ya+$R]
    for { set x $x0 } { $x < $x1 } { incr x $R } {
	if { $x < 0 } continue
	for { set y 0 } { $y < $Ye } { incr y $r } {
	    $imageName put #000 -to $x $y
	}
    }
    # update
    set Xe [expr $xe-$xa+$R]
    for { set y $y0 } { $y < $y1 } { incr y $R } {
	if { $y < 0 } continue
	for { set x 0 } { $x < $Xe } { incr x $r } {
	    $imageName put #000 -to $x $y
	}
    }
    # update

    #und jetzt noch ein feines grid darstellen
    if { $raster > 5  } {
	set R [expr 5*$raster]
	if { $raster >= 20 } { set R [expr 2*$raster] }
	if { $raster >= 50 } { set R [expr $raster] }

	set x0 [expr int($xa/$R)*$R - $xa]
	set y0 [expr int($ya/$R)*$R - $ya]
	set x1 [expr $xe-$xa+$R]
	set y1 [expr $ye-$ya+$R]

	for { set x $x0 } { $x < $x1 } { incr x $R } {
	    if { $x < 0 } continue
	    for { set y $y0 } { $y < $y1 } { incr y $R } {
		if { $y < 0 } continue
		$imageName put #000 -to $x $y
	    }
	}
    }
}
