##################################################################
##*****************************************************************
##* Copyright (C) 1998 Sylvio Triebel
##*
##* Id           : $Id: group.tcl,v 1.4 1998/01/16 12:54:52 silvio Exp $
##* Revision     : $Revision: 1.4 $
##* Datum        : 16.1.98
##* Systems      : Tcl/Tk 7.6 8.0, [incr tcl] 
##*
##*
##* Documentation: 
##*
##*****************************************************************

set grcount 0

proc tkdrawGroupSelected {} {
    global tkdraw grcount

    set first_item [lindex [$tkdraw(canvas) find withtag selected] 1]

    foreach id [$tkdraw(canvas) find withtag selected] {
	set tags [$tkdraw(canvas) gettags $id]
	set idx [lsearch $tags endgrp]
	set tags [linsert $tags $idx g$grcount]
	$tkdraw(canvas) itemconfigure $id -tags $tags
    }
    incr grcount
    
    tkdrawDeselectAll
    tkdrawSelectItem $first_item
}

proc tkdrawUngroupSelected {} {
    global tkdraw

    foreach id [$tkdraw(canvas) find withtag selected] {
	set tags [$tkdraw(canvas) gettags $id]
	set idx [expr [lsearch $tags endgrp]-1]
	if { [lindex $tags $idx] != "grp" } {
	    set tags [lreplace $tags $idx $idx]
	    $tkdraw(canvas) itemconfigure $id -tags $tags
	}
    }
    tkdrawDeselectAll
}

proc tkdrawGetGroups { id } {
    global tkdraw

    set tags [$tkdraw(canvas) gettags $id]
    set first [expr [lsearch $tags grp]+1]
    set last  [expr [lsearch $tags endgrp]-1]

    if { $first <= $last } {
	return [lrange $tags $first $last]
    }
    return ""
}

array set grmap [list]

proc tkdrawResetGroupMap {} {
    global tkdraw grcount grmap

    catch { unset grmap }
    array set grmap [list]
}

proc tkdrawInitGroupManager {} {
    global tkdraw grcount grmap

    set grcount 0
    tkdrawResetGroupMap
}

proc tkdrawRemapGroups { id } {
    global tkdraw grcount grmap

    set tags [$tkdraw(canvas) gettags $id]
    set first [expr [lsearch $tags grp]+1]
    set last  [expr [lsearch $tags endgrp]-1]

    if { $first <= $last } {
	set groups [lrange $tags $first $last]

	set newgrp [list]
	foreach group $groups {
	    if { [info exists grmap($group)] } {
		lappend newgrp $grmap($group)
	    } else {
		lappend newgrp g$grcount
		set grmap($group) g$grcount
		incr grcount
	    }
	}

	set tags [eval lreplace \"$tags\" $first $last $newgrp]
	$tkdraw(canvas) itemconfigure $id -tags $tags
    }
    set groups [tkdrawGetGroups $id]
} 

