##################################################################
##*****************************************************************
##* Copyright (C) 1998 Sylvio Triebel
##*
##* Id           : $Id: help.tcl,v 1.2 1998/01/16 12:54:52 silvio Exp $
##* Revision     : $Revision: 1.2 $
##* Datum        : 16.1.98
##* Systems      : Tcl/Tk 7.6 8.0, [incr tcl] 
##*
##*
##* Documentation: 
##*
##*****************************************************************


proc tkdrawDescribeEditmode { } {
    global tkdraw

    set w .helpmode
    catch { destroy $w }

    toplevel $w
    wm title $w "Describe Mode"
    wm iconname $w "Describe Mode"
    wm geometry $w 600x600

    scrollbar $w.vscroll -command "$w.text yview"
    pack $w.vscroll -side right -fill y

    set t [text $w.text -yscrollcommand "$w.vscroll set"]

    pack $t -fill both -expand yes
    
    $t tag configure text -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
    $t tag configure h1 -font -*-Helvetica-Medium-R-Bold--*-180-*-*-*-*-*-*
    $t tag configure h2 -font -*-Helvetica-Medium-R-Bold--*-160-*-*-*-*-*-*
    $t tag configure h3 -font -*-Helvetica-Medium-R-Bold--*-140-*-*-*-*-*-*
    $t tag configure h4 -font -*-Helvetica-Medium-R-Bold--*-120-*-*-*-*-*-*

    switch -exact $tkdraw(edit) {
	select {
	    tkdrawAddText $t h1 "Selection Mode"

	    tkdrawAddText $t h2 "ButtonPress-1"
	    tkdrawAddText $t h3 "If on Item"
	    tkdrawAddText $t text "Select a single item"
	    tkdrawAddText $t h3 "If not on Item"
	    tkdrawAddText $t text "Deselect all or start Region."
	    tkdrawAddText $t text "If region is started, another click will finisch the region"
	    

	    tkdrawAddText $t h2 "Shift-ButtonPress-1"
	    tkdrawAddText $t text "Add or remove a single item from/to selection"

	    tkdrawAddText $t h2 "ButtonPress-3"
	    tkdrawAddText $t text "Start moving the selected items."
	    tkdrawAddText $t text "If no item was selected, the item below the mouse cursor will be selected."
	    tkdrawAddText $t text "To move the item hold the button pressed and move the items to the desired place"
	}
	alter {
	    tkdrawAddText $t h1 "Reshape Mode"

	    tkdrawAddText $t h2 "ButtonPress-1"
	    tkdrawAddText $t text "Select a single item for reshape and drawing handles"

	    tkdrawAddText $t h2 "ButtonPress-1 on handle"
	    tkdrawAddText $t text "To configurate a point, hold button pressed and move the mouse to the desired place"
	}
	default {
	    tkdrawAddText $t h1 "Mode: $tkdraw(edit)"

	    
	    tkdrawAddText $t text "No help available"
	}
    }
}

proc tkdrawDescribeKeybindings { } {
    global tkdraw

    global tkdraw

    set w .helpmode
    catch { destroy $w }

    toplevel $w
    wm title $w "Describe Mode"
    wm iconname $w "Describe Mode"
    wm geometry $w 600x600

    scrollbar $w.vscroll -command "$w.text yview"
    pack $w.vscroll -side right -fill y

    set t [text $w.text -yscrollcommand "$w.vscroll set"]

    pack $t -fill both -expand yes
    
    $t tag configure text -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
    $t tag configure h1 -font -*-Helvetica-Medium-R-Bold--*-180-*-*-*-*-*-*
    $t tag configure h2 -font -*-Helvetica-Medium-R-Bold--*-160-*-*-*-*-*-*
    $t tag configure h3 -font -*-Helvetica-Medium-R-Bold--*-140-*-*-*-*-*-*
    $t tag configure h4 -font -*-Helvetica-Medium-R-Bold--*-120-*-*-*-*-*-*

    tkdrawAddText $t h1 "Global Keybindings"

    tkdrawAddText $t h2 <d>
    tkdrawAddText $t text "Duplicate selected items."


    tkdrawAddText $t h2 <Control-d>
    tkdrawAddText $t text "Delete selected items."


    tkdrawAddText $t h2 <Meta-d>
    tkdrawAddText $t text "Delete selected items."


    tkdrawAddText $t h2 <Control-c>
    tkdrawAddText $t text "Copy selected items."


    tkdrawAddText $t h2 <Control-v>
    tkdrawAddText $t text "Paste selected items."


    tkdrawAddText $t h2 <f>
    tkdrawAddText $t text "Bring selected items to front"


    tkdrawAddText $t h2 <b>
    tkdrawAddText $t text "Bring selected items to back"


    tkdrawAddText $t h2 <g>
    tkdrawAddText $t text "Group selected items."


    tkdrawAddText $t h2 <u>
    tkdrawAddText $t text "Unroup selected items."


    tkdrawAddText $t h2 <s>
    tkdrawAddText $t text "Enter select mode"


    tkdrawAddText $t h2 <a>
    tkdrawAddText $t text "Enter reshape mode"


    tkdrawAddText $t h2 <r>
    tkdrawAddText $t text "Enter rectangle mode"


    tkdrawAddText $t h2 <o>
    tkdrawAddText $t text "Enter oval mode"


    tkdrawAddText $t h2 <l>
    tkdrawAddText $t text "Enter line mode"


    tkdrawAddText $t h2 <c>
    tkdrawAddText $t text "Enter curve mode"


    tkdrawAddText $t h2 <p>
    tkdrawAddText $t text "Enter polygon mode"


    tkdrawAddText $t h2 <y>
    tkdrawAddText $t text "Enter filled bezier mode"
}

proc tkdrawAddText { win tag text } {
    if { $tag == "h1" || $tag == "h2" } {
	$win insert end "\n" $tag
    }

    $win insert end "$text\n" $tag

}

