##################################################################
##*****************************************************************
##* Copyright (C) 1998 Sylvio Triebel
##*
##* Id           : $Id: region.tcl,v 1.3 1998/01/28 16:33:56 silvio Exp $
##* Revision     : $Revision: 1.3 $
##* Datum        : 16.1.98
##* Systems      : Tcl/Tk 7.6 8.0, [incr tcl] 
##*
##*
##* Documentation: 
##*
##*****************************************************************

#*********************** REGION ****************************************

proc tkdrawBindRegion { {immediate 0} {x 0} {y 0} } {
    global tkdraw

    #alle alten bindings loeschen
    tkdrawInitCanvasBindings

    set tkdraw(regionact) 0

    if { $immediate == 1 } {
	#Region sofort aktivieren
	tkdrawMarkRegion $x $y
    }

    bind $tkdraw(canvas) <ButtonPress-1> { 
	tkdrawMarkRegion $tkdrawX $tkdrawY
    }
    bind $tkdraw(c) <ButtonRelease-1> {
	if { $tkdraw(regionact) } {
	    tkdrawMarkRegion $tkdrawX $tkdrawY
	}
    } 
    bind $tkdraw(canvas) <Motion> { 
	set tkdrawX [$tkdraw(canvas) canvasx %x $tkdraw(raster)] 
	set tkdrawY [$tkdraw(canvas) canvasy %y $tkdraw(raster)]
	tkdrawResizeRegion $tkdrawX $tkdrawY
    }
}

proc tkdrawMarkRegion { x y } {
    global tkdraw

    if { ($tkdraw(oldx) == $x) || ($tkdraw(oldy) == $y) } {
	return
    }

    if { $tkdraw(regionact) == 0 } {
	catch { $tkdraw(canvas) delete withtag regionRect }
	set tkdraw(oldx) $x
	set tkdraw(oldy) $y
	set tkdraw(regionact) 1
	$tkdraw(canvas) create rectangle $x $y $x $y -tags regionRect \
	    -outline black
    } else {
	set tkdraw(regionact) 0
	$tkdraw(canvas) coords regionRect $tkdraw(oldx) $tkdraw(oldy) $x $y
	set tkdraw(region) [list $tkdraw(oldx) $tkdraw(oldy) $x $y]
	#aktuelle Bindings wieder herstellen
	tkdrawRestoreEditmode $tkdraw(canvas)
	
	catch { $tkdraw(canvas) delete withtag regionRect }

	foreach cmd $tkdraw(regionhook) { eval $cmd }
	set tkdraw(regionhook) ""
	set tkdraw(oldx) -1
	set tkdraw(oldy) -1
    }
}

proc tkdrawResizeRegion { x y } {
    global tkdraw
    
    if { $tkdraw(regionact) == 1 } {
	$tkdraw(canvas) coords regionRect $tkdraw(oldx) $tkdraw(oldy) $x $y
    }
}

