##################################################################
##*****************************************************************
##* Copyright (C) 1998 Sylvio Triebel
##*
##* Id           : $Id: ruler.tcl,v 1.2 1998/01/16 12:54:52 silvio Exp $
##* Revision     : $Revision: 1.2 $
##* Datum        : 16.1.98
##* Systems      : Tcl/Tk 7.6 8.0, [incr tcl] 
##*
##*
##* Documentation: 
##*
##*****************************************************************

#*********************** LINEAL ****************************************

proc tkdrawBindLineal { } {
    global tkdraw

    #alle alten bindings loeschen
    tkdrawInitCanvasBindings

    bind $tkdraw(canvas) <ButtonPress-1> { 
	tkdrawMarkLineal [$tkdraw(canvas) canvasx %x $tkdraw(raster)] \
		[$tkdraw(canvas) canvasy %y $tkdraw(raster)]
    }
    bind $tkdraw(canvas) <Motion> { 
	tkdrawResizeLineal [$tkdraw(canvas) canvasx %x $tkdraw(raster)] \
		[$tkdraw(canvas) canvasy %y $tkdraw(raster)]
    }
}

proc tkdrawMarkLineal { x y } {
    global tkdraw

    if { $tkdraw(linealact) == 0 } {
	catch { $tkdraw(canvas) delete $tkdraw(lineal) }
	catch { $tkdraw(canvas) delete $tkdraw(dist) }
	set tkdraw(linealact) 1
	set tkdraw(oldx) $x
	set tkdraw(oldy) $y
	set tkdraw(dist) [$tkdraw(canvas) create text $x [expr $y-10] -text "dx:0 dy:0"]
	set tkdraw(lineal) [$tkdraw(canvas) create line $x $y $x $y -fill yellow]
    } else {
	set tkdraw(linealact) 0
	$tkdraw(canvas) coords $tkdraw(lineal) $tkdraw(oldx) $tkdraw(oldy) $x $y
	$tkdraw(canvas) coords $tkdraw(dist) [expr ($x+$tkdraw(oldx))/2]  [expr ($y+$tkdraw(oldy))/2-10]
	set dx [format "%.1f" [expr ($x-$tkdraw(oldx))/$tkdraw(scaling)]]
	set dy [format "%.1f" [expr ($y-$tkdraw(oldy))/$tkdraw(scaling)]]
	set dist [format "%.1f" [expr sqrt(($x-$tkdraw(oldx))*($x-$tkdraw(oldx))+($y-$tkdraw(oldy))*($y-$tkdraw(oldy)))/$tkdraw(scaling)]]
	$tkdraw(canvas) itemconfigure $tkdraw(dist) -text "dx=$dx dy=$dy  s=$dist"

	tkdrawRestoreEditmode $tkdraw(canvas)
    }
}

proc tkdrawResizeLineal { x y } {
    global tkdraw

    if { $tkdraw(linealact) == 1 } {
	$tkdraw(canvas) coords $tkdraw(lineal) $tkdraw(oldx) $tkdraw(oldy) $x $y
	$tkdraw(canvas) coords $tkdraw(dist) [expr ($x+$tkdraw(oldx))/2]  [expr ($y+$tkdraw(oldy))/2-10]
	set dx [format "%.2f" [expr ($x-$tkdraw(oldx))/$tkdraw(scaling)]]
	set dy [format "%.2f" [expr ($y-$tkdraw(oldy))/$tkdraw(scaling)]]
	set dist [format "%.2f" [expr sqrt(($x-$tkdraw(oldx))*($x-$tkdraw(oldx))+($y-$tkdraw(oldy))*($y-$tkdraw(oldy)))/$tkdraw(scaling)]]
	$tkdraw(canvas) itemconfigure $tkdraw(dist) -text "dx=$dx dy=$dy  s=$dist"
    }
}

