##################################################################
##*****************************************************************
##* Copyright (C) 1998 Sylvio Triebel
##*
##* Id           : $Id: text.tcl,v 1.3 1998/01/16 12:54:52 silvio Exp $
##* Revision     : $Revision: 1.3 $
##* Datum        : 16.1.98
##* Systems      : Tcl/Tk 7.6 8.0, [incr tcl] 
##*
##*
##* Documentation: 
##*
##*****************************************************************

#*********************** Text ****************************************
# label .texteditor -textvariable tkdraw(currenttext)


set tkdraw(currenttext) ""
proc tkdrawBindText { canvas } {
    global tkdraw

    set tkdraw(canvas) $canvas

    #alle alten bindings loeschen
    tkdrawInitCanvasBindings

    set tkdraw(textactive) 0

    bind $tkdraw(c) <ButtonPress-1> { 
	set tkdraw(x) [$tkdraw(c) canvasx %x $tkdraw(raster)]
	set tkdraw(y) [$tkdraw(c) canvasy %y $tkdraw(raster)]

	set id [$tkdraw(c) find withtag current]

	if { $tkdraw(textactive) == 0 } {
	    set tkdraw(textactive) 1

	    tkdrawDeselectAll
	    catch { 
		destroy .texted
	    }
	    entry .texted -textvariable tkdraw(currenttext) \
		-relief flat -borderwidth 0 -justify center -width 0 \
		-font $tkdraw(fontname) \
		-foreground $tkdraw(color) \
		-background white

	    bind .texted <Escape> {
		$tkdraw(canvas) delete $tkdraw(cureditor)
		tkdrawUpdateText
		set tkdraw(textactive) 0
	    }
	    tkdrawClearGlobalKeybindings

	    set tkdraw(oldx) $tkdraw(x)
	    set tkdraw(oldy) $tkdraw(y)
	    if { [$tkdraw(canvas) type $id] == "text"} {
		#text modifizieren
		set coords [$tkdraw(canvas) coords $id]
		set tkdraw(oldx) [lindex $coords 0] 
		set tkdraw(oldy) [lindex $coords 1] 

		set tkdraw(current) $id
		.texted configure -font [tkdrawGetFontName $id]
		set tkdraw(currenttext) [lindex [$tkdraw(canvas) itemconfigure $id -text] 4]
		set tkdraw(cureditor) [$tkdraw(c) create window \
					   $tkdraw(oldx) $tkdraw(oldy) \
					   -anchor $tkdraw(anchor) \
					   -tags "temp selected" \
					   -window .texted ]
	    } else {
		#neuen Text erzeugen
		set tkdraw(current) 0
		set tkdraw(currenttext) ""
		set tkdraw(cureditor) [$tkdraw(c) create window \
					   $tkdraw(x) $tkdraw(y) \
					   -anchor $tkdraw(anchor) \
					   -tags "temp selected" \
					   -window .texted ]
		focus .texted
	    }
	} else {
	    set tkdraw(textactive) 0
	    tkdrawSetGlobalKeybindings

	    $tkdraw(canvas) delete $tkdraw(cureditor)
	    tkdrawUpdateText
	    tkdrawSelectItem $tkdraw(current)
	}
    }

    bind $tkdraw(c) <ButtonPress-3> { 
	set x [$tkdraw(c) canvasx %x $tkdraw(raster)]
	set y [$tkdraw(c) canvasy %y $tkdraw(raster)]

	if { $tkdraw(textactive) } {
	    set tkdraw(textactive) 0
	    tkdrawSetGlobalKeybindings

	    $tkdraw(canvas) delete $tkdraw(cureditor)
	    tkdrawUpdateText
	    tkdrawSelectItem $tkdraw(current)
	} else {
	    tkdrawBindMove $x $y
	}
    }
    bind $tkdraw(c) <Motion> { 
	set x [eval $tkdraw(c) canvasx %x $tkdraw(raster)]
	set y [eval $tkdraw(c) canvasy %y $tkdraw(raster)]
	set tkdraw(x) [expr $x/$tkdraw(scaling)]
	set tkdraw(y) [expr $y/$tkdraw(scaling)]
    }
}

proc tkdrawBindTextDestructor { canvas } {
    global tkdraw

    #finish current Object
    if { $tkdraw(textactive) } {
	set tkdraw(textactive) 0
	tkdrawSetGlobalKeybindings

	$tkdraw(canvas) delete $tkdraw(cureditor)
	tkdrawUpdateText
	tkdrawSelectItem $tkdraw(current)
    }

    $tkdrsw(canvas) delete withtag temp
}

proc tkdrawCreateEditor { x y } {
    global tkdraw

    set tkdraw(cureditor) [$tkdraw(c) create window \
			       $tkdraw(oldx) $tkdraw(oldy) \
			       -window .texted ]

    focus .texted

}

proc tkdrawUpdateText { } {
    global tkdraw

    set font "\{$tkdraw(font) $tkdraw(fontsize) $tkdraw(fontstyle)\}"

    if { $tkdraw(current) } {
	#nur modifizieren
	set id $tkdraw(current)
	set bg [expr $id-1]

	$tkdraw(canvas) itemconfigure $bg -text $tkdraw(currenttext) -anchor $tkdraw(anchor)
	$tkdraw(canvas) itemconfigure $id -text $tkdraw(currenttext) -anchor $tkdraw(anchor)

    } else {
	#text neu erzeugen

	#keinen leeren Text erzeugen
	if { $tkdraw(currenttext) == "" } return

	#Backgroundobject
	$tkdraw(canvas) create text $tkdraw(oldx) $tkdraw(oldy) \
	    -text $tkdraw(currenttext) \
	    -font $tkdraw(fontname) \
	    -fill white \
	    -justify $tkdraw(justifytext) \
	    -anchor $tkdraw(anchor) \
	    -tags "item text bg grp endgrp font $font"

	#Foregroundobject
	set tkdraw(current) [$tkdraw(canvas) create text \
				 $tkdraw(oldx) $tkdraw(oldy) \
				 -text $tkdraw(currenttext) \
				 -font $tkdraw(fontname) \
				 -fill $tkdraw(color) \
				 -stipple $tkdraw(stipple) \
				 -justify $tkdraw(justifytext) \
				 -anchor $tkdraw(anchor) \
				 -tags "item text grp endgrp font $font" ]
    }
}


#--------------------------------------------------------------------------------

proc tkdrawComputeFontName { } {
    global tkdraw tk_version

    set size [expr round($tkdraw(fontsize)*$tkdraw(scaling)*10)]

    set tkdraw(fontname) "-*-$tkdraw(font)-$tkdraw(fontstyle)-R-Normal--*-$size-*-*-*-*-*-*"
}

			    
proc tkdrawGetFont { id } {
    global tkdraw

    set tags [$tkdraw(canvas) gettags $id]
    set i [lsearch $tags font]

    set fnt [lindex $tags [expr $i+1]]

    #kompatibilitaet!
    if { [llength $fnt] < 3 } {
	lappend fnt "Medium"
    }

    return $fnt 
}

proc tkdrawGetFontName { id } {
    global tkdraw

    set fnt [tkdrawGetFont $id]
    set size [expr round([lindex $fnt 1]*$tkdraw(scaling)*10)]
    set fname -*-[lindex $fnt 0]-[lindex $fnt 2]-R-Normal--*-$size-*-*-*-*-*-*

    return $fname
}

proc tkdrawSetFont { id fnt } {
    global tkdraw

    set tags [$tkdraw(canvas) gettags $id]
    set i [expr [lsearch $tags font]+1]

    set tags [lreplace $tags $i $i "$fnt" ]
    $tkdraw(canvas) itemconfigure $id -tags $tags
}

proc tkdrawRescaleFontSelected { } {
    global tkdraw

    foreach id [$tkdraw(canvas) find withtag selected] {
	tkdrawRescaleFont $id
    }
}

proc tkdrawRescaleFont { id {fak 1.0} } {
    global tkdraw 

    if { [$tkdraw(canvas) type $id] == "text" } {
	set fnt [lreplace [tkdrawGetFont $id] 1 1 $tkdraw(fontsize)]
	tkdrawSetFont $id $fnt
		
	set size [expr round([lindex $fnt 1]*$tkdraw(scaling)*10*$fak)]
	set fname -*-[lindex $fnt 0]-[lindex $fnt 2]-R-Normal--*-$size-*-*-*-*-*-*

	$tkdraw(canvas) itemconfigure $id -font $fname
    }
}

proc tkdrawResetFontSelected { } {
    global tkdraw tk_version

    foreach id [$tkdraw(canvas) find withtag selected] {
	if { [$tkdraw(canvas) type $id] == "text" } {
	    set fnt [lreplace [tkdrawGetFont $id] 0 0 $tkdraw(font)]
	    set fnt [lreplace $fnt 2 2 $tkdraw(fontstyle)]
	    tkdrawSetFont $id $fnt
		
	    set size [expr round([lindex $fnt 1]*$tkdraw(scaling)*10)]
	    set fname -*-$tkdraw(font)-$tkdraw(fontstyle)-R-Normal--*-$size-*-*-*-*-*-*

	    $tkdraw(canvas) itemconfigure $id -font $fname
	}
    }
}

proc tkdrawRescaleFonts { } {
    global tkdraw

    foreach id [$tkdraw(canvas) find withtag font] {
	set fnt [tkdrawGetFont $id]
		
	set size [expr round([lindex $fnt 1]*$tkdraw(scaling)*10)]
	set fname -*-[lindex $fnt 0]-[lindex $fnt 2]-R-Normal--*-$size-*-*-*-*-*-*
	$tkdraw(canvas) itemconfigure $id -font $fname
    }   
}
