##################################################################
##*****************************************************************
##* Copyright (C) 1998 Sylvio Triebel
##*
##* Id           : $Id: zoom.tcl,v 1.4 1998/01/16 12:54:52 silvio Exp $
##* Revision     : $Revision: 1.4 $
##* Datum        : 16.1.98
##* Systems      : Tcl/Tk 7.6 8.0, [incr tcl] 
##*
##*
##* Documentation: 
##*
##*****************************************************************

#*********************** ZOOMING ****************************************

proc tkdrawZoom { factor } {
    global tkdraw

#     set tkdraw(raster) [expr round($factor * 10)]
    set raster [expr round($factor * 10)]
#     set factor [expr $tkdraw(raster).0 / 10]
    set factor [expr $raster.0 / 10]
    set sfactor [expr $factor/$tkdraw(scaling)]

    set w [winfo width $tkdraw(c)]
    set h [winfo height $tkdraw(c)]

    set xa [expr [$tkdraw(c) canvasx 0] / $tkdraw(scaling)]
    set xe [expr [$tkdraw(c) canvasx $w] / $tkdraw(scaling)]
    set ya [expr [$tkdraw(c) canvasy 0] / $tkdraw(scaling)]
    set ye [expr [$tkdraw(c) canvasy $h] / $tkdraw(scaling)]

    set tkdraw(scaling) $factor

    set xori [expr $xa + ($xe-$xa)*(1-1/$sfactor)/2]
    set yori [expr $ya + ($ye-$ya)*(1-1/$sfactor)/2]

    $tkdraw(c) scale all 0 0 $sfactor $sfactor

    $tkdraw(c) configure -scrollregion \
	"0 0 [expr $tkdraw(canWidth)*$factor] [expr $tkdraw(canHeight)*$factor]"

    $tkdraw(c) xview moveto [expr $xori/$tkdraw(canWidth)]
    $tkdraw(c) yview moveto [expr $yori/$tkdraw(canHeight)]

    if { $tkdraw(gravity) } {
	set tkdraw(raster) $raster
    }
    tkdrawComputeFontName
    tkdrawRescaleFonts
    tkdrawRedrawGrid
} 

proc tkdrawZoomRegion { {region 0} {scfaktor 0.95}} {
    global tkdraw

    if { $region == 0 } {
	lappend tkdraw(regionhook) "tkdrawZoomRegion \$tkdraw(region)"
	tkdrawBindRegion $tkdraw(canvas)
	return
    }
    
    set xa [$tkdraw(c) canvasx 0]
    set xe [$tkdraw(c) canvasx [winfo width $tkdraw(c)]]
    set ya [$tkdraw(c) canvasy 0]
    set ye [$tkdraw(c) canvasy [winfo height $tkdraw(c)]]

    set x1 [lindex $region 0]
    set y1 [lindex $region 1]
    set x2 [lindex $region 2]
    set y2 [lindex $region 3]

    set xreg [expr $x1/$tkdraw(scaling)]
    set yreg [expr $y1/$tkdraw(scaling)]

    set scalex [expr ($xe-$xa)/($x2-$x1)]
    set scaley [expr ($ye-$ya)/($y2-$y1)]

    set scale [abs [expr [min $scalex $scaley]*$scfaktor]]

    tkdrawZoom [expr $scale * $tkdraw(scaling)]

    $tkdraw(c) xview moveto [expr $xreg/$tkdraw(canWidth)]
    $tkdraw(c) yview moveto [expr $yreg/$tkdraw(canHeight)]
}

