##################################################################
##*****************************************************************
##* Copyright (C) 1998 Sylvio Triebel
##*
##* Id           : $Id: tkdraw.tcl,v 1.3 1998/01/28 16:37:16 silvio Exp $
##* Revision     : $Revision: 1.3 $
##* Datum        : 16.1.98
##* Systems      : Tcl/Tk 7.6 8.0, [incr tcl] 
##*
##*
##* Documentation: 
##*
##*****************************************************************

#look for instadded files...
if { ![info exist tkdraw(HOME)] } {
    if { [info exist env(TKDRAW_HOME)] } {
	set tkdraw(HOME)    $env(TKDRAW_HOME)
	if { ![file exist $tkdraw(HOME)/tkdraw.tcl] } {
	    puts "fatal error: environment variable TKDRAW_HOME is not correct"
	    exit
	}
    } else {
	if { [info exist env(HOME)] } {
	    set tkdraw(HOME)    $env(HOME)/soft/tkdraw
	    if { ![file exist $tkdraw(HOME)/tkdraw.tcl] } {
		puts "please set environment variable TKDRAW_HOME"
		exit
	    }
	} elseif { [file exist /tkdraw/tkdraw.tcl] } {
	    set tkdraw(HOME)  /tkdraw
	} else {
	    puts "please set environment variable TKDRAW_HOME"
	    exit
	}
    }
}

set tkdraw(LIB)     $tkdraw(HOME)/lib
set tkdraw(BITMAP)  $tkdraw(HOME)/bitmap
set tkdraw(CLIPART) $tkdraw(HOME)/clipart

foreach component [glob $tkdraw(LIB)/*.tcl] {
    puts "loading $component ..."
    source $component
}

#hohe Genauigkeit einstellen
set tcl_precision    12

set tkdraw(revision)     "\$Revision: 1.3 $"
set tkdraw(version)     "1.0"

#--------------- DEFAULTS ----------------------------------------------
set tkdraw(r)           .tkdraw
set tkdraw(c)           .tkdraw.canvas
set tkdraw(statustext)  ""
set tkdraw(scaling)     1.0
set tkdraw(rastersize)  10
set tkdraw(raster)      10
set tkdraw(fontname)    -*-Helvetica-Medium-R-Normal--*-100-*-*-*-*-*-*
set tkdraw(font)        Helvetica
set tkdraw(fontsize)    12 
set tkdraw(fontstyle)   Medium
set tkdraw(justifytext) center  
set tkdraw(anchor)      w
set tkdraw(lineal)      0
set tkdraw(linealact)   0
set tkdraw(region)      ""
set tkdraw(regionact)   0
set tkdraw(regionhook)  ""
set tkdraw(printOption) all
set tkdraw(postscript)  1
set tkdraw(filename)    "noname.tdr"
set tkdraw(gravity)     1
set tkdraw(showgrid)    0
set tkdraw(edit)        select
set tkdraw(color)       black
set tkdraw(bgcolor)     ""
set tkdraw(fill)        ""
set tkdraw(layer)       L0
set tkdraw(lwidth)      1
set tkdraw(arrow)       none
set tkdraw(capstyle)    butt
set tkdraw(joinstyle)   miter
# set tkdraw(stipple)     @$tkdraw(BITMAP)/stipple0.xbm
set tkdraw(stipple)     ""
set tkdraw(selectbox)   0

#variables for alignment
set tkdraw(refx)   center
set tkdraw(refy)   center
set tkdraw(objx)   center
set tkdraw(objy)   center
set tkdraw(objmargin)   0


#nach vertikaler Anordnung sortiert
set tkdraw(layers) [list L0 L1 L2 L3 L4 L5 L6 L7 L8 L9]

#Layer Properties: show print prop
set tkdraw(prop,L0)      [list 1 1 unknown]
set tkdraw(prop,L1)      [list 1 1 unknown]
set tkdraw(prop,L2)      [list 1 1 unknown]
set tkdraw(prop,L3)      [list 1 1 unknown]
set tkdraw(prop,L4)      [list 1 1 unknown]
set tkdraw(prop,L5)      [list 1 1 unknown]
set tkdraw(prop,L6)      [list 1 1 unknown]
set tkdraw(prop,L7)      [list 1 1 unknown]
set tkdraw(prop,L8)      [list 1 1 unknown]
set tkdraw(prop,L9)      [list 1 1 unknown]

after 0 tkdrawRun

proc tkdrawRun { } {
    global argv tkdraw

    wm title . "TKDraw"
    wm iconname . "TKDraw"
    wm geometry . 800x600

    wm protocol . WM_DELETE_WINDOW tkdrawQuitDlg

    #Rootframe
    frame $tkdraw(r)
    pack $tkdraw(r)  -expand yes -fill both

    # Menubar:
    frame $tkdraw(r).mbar -relief raised -bd 2
    pack $tkdraw(r).mbar -side top -fill x

    # Statuszeile
    label $tkdraw(r).sline -relief sunken -textvariable tkdraw(statustext) -justify left -anchor w
    pack $tkdraw(r).sline -side bottom -fill x

#     #******************** Obere Toolbar **************************
#     frame $tkdraw(r).buttons
# #     pack $tkdraw(r).buttons -side right -fill y
#     pack $tkdraw(r).buttons -side top -fill x

#     set tkdraw(tbcount) 0
#     proc mkTBButton { bitmap cmd } {
# 	global tkdraw

# 	button $tkdraw(r).buttons.tb$tkdraw(tbcount) \
# 	    -image [image create photo -file $tkdraw(BITMAP)/$bitmap] \
# 	    -command $cmd

# # 	pack $tkdraw(r).buttons.tb$tkdraw(tbcount) -side top
# 	pack $tkdraw(r).buttons.tb$tkdraw(tbcount) -side left
# 	incr tkdraw(tbcount)
#     }

#     mkTBButton zoom_in.gif  { tkdrawZoom [expr $tkdraw(scaling)*1.5] }
#     mkTBButton zoom_out.gif { tkdrawZoom [expr $tkdraw(scaling)*0.75] }
#     mkTBButton zoom_fit.gif { tkdrawZoomRegion [$tkdraw(c) bbox item] }
#     mkTBButton zoom_reg.gif { tkdrawZoomRegion 0 }

    #******************** Linke Toolbar **************************
    set w [frame $tkdraw(r).lb]
    pack $w -side left -fill y

    set tkdraw(LeftToolbar) $w
 
    set w [frame $tkdraw(r).lb.but]
    pack $w -side top
    
    set tkdraw(b_row) 0; set tkdraw(b_column) 0
    proc mkButton { bitmap var } {
	global tkdraw

	set b $tkdraw(r).lb.$var
	button $b \
		-image [image create photo -file $tkdraw(BITMAP)/$bitmap] \
		-command "set tkdraw(edit) $var" 
	pack $b -side top
    }

    proc mkRadioButton { bitmap var {helptext ""}} {
	global tkdraw

# 	set b $tkdraw(r).lb.$var
	set b $tkdraw(r).lb.but.$var
	radiobutton $b \
		-image [image create photo -file $tkdraw(BITMAP)/$bitmap] \
		-command "set tkdraw(edit) $var" \
		-variable tkdraw(edit) -value $var
# 	pack $b -side top
	grid $b -row $tkdraw(b_row) -column $tkdraw(b_column)
	incr tkdraw(b_column)
	if { $tkdraw(b_column) > 1 } { 
	    set tkdraw(b_column) 0
	    incr tkdraw(b_row)
	}

	bind $b <Enter> "set tkdraw(statustext) \"$helptext\""
	bind $b <Leave> "tkdrawPrintStatusline x x x"
    }
    set tkdraw(tb_label_count) 0
    proc mkSeparator {} {
	global tkdraw
	label $tkdraw(r).lb.l$tkdraw(tb_label_count)
	pack $tkdraw(r).lb.l$tkdraw(tb_label_count)  -side top
	incr tkdraw(tb_label_count)
    }

    mkRadioButton select.gif    select  "Enter  Select mode"
    mkRadioButton reshape.gif   alter   "Enter  Reshape mode"
    mkSeparator
    mkRadioButton rect.gif      rect    "Enter  Rectangle drawing mode"
    mkRadioButton oval.gif      oval    "Enter  Oval drawing mode"
    mkRadioButton polyline.gif  line    "Enter  Line drawing mode"
    mkRadioButton curve.gif     curve   "Enter  Curve drawing mode"
    mkRadioButton polygon.gif   poly    "Enter  Polygon drawing mode"
    mkRadioButton patate.gif    spoly   "Enter  Bezier-Polygon mode"
    mkRadioButton alpha.gif     text    "Enter  Text mode"
#     mkSeparator

    #align-canvas
    tkdrawCreateCmdCanvas "cmdcan.tdr" "$tkdraw(r).lb" "-side top" "" 
    mkSeparator

    #******************** RECHTE BUTTONLEISTE **************************
    frame $tkdraw(r).buttons
    pack $tkdraw(r).buttons -side right -fill y

    set tkdraw(tbcount) 0
    proc mkTBButton { bitmap cmd } {
	global tkdraw

	button $tkdraw(r).buttons.tb$tkdraw(tbcount) \
	    -image [image create photo -file $tkdraw(BITMAP)/$bitmap] \
	    -command $cmd

	pack $tkdraw(r).buttons.tb$tkdraw(tbcount) -side top
	incr tkdraw(tbcount)
    }

    mkTBButton zoom_in.gif  { tkdrawZoom [expr $tkdraw(scaling)*1.5] }
    mkTBButton zoom_out.gif { tkdrawZoom [expr $tkdraw(scaling)*0.75] }
    mkTBButton zoom_fit.gif { tkdrawZoomRegion [$tkdraw(c) bbox item] }
    mkTBButton zoom_reg.gif { tkdrawZoomRegion 0 }

#     button $tkdraw(r).buttons.ruler -text "Ruler"  -width 10 -command { tkdrawBindLineal }
#     pack $tkdraw(r).buttons.ruler -side top -pady 2m

    set tkdraw(x) 0
    set tkdraw(y) 0
#     label $tkdraw(r).buttons.x -textvariable tkdraw(x) -relief sunken
#     label $tkdraw(r).buttons.y -textvariable tkdraw(y) -relief sunken
#     pack $tkdraw(r).buttons.x $tkdraw(r).buttons.y -side top
    

    #******************** Menueleiste *****************************

    #******* File ************
    set m $tkdraw(r).mbar.file
    menubutton $m -text File -underline 0 -menu $m.menu
    pack $m -side left
    menu $m.menu

    $m.menu add command -label New  -command tkdrawNewFile
    $m.menu add command -label Open -command tkdrawOpenFile
    $m.menu add command -label Save -command "tkdrawSaveFile 1"
    $m.menu add command -label "Save as ..." -command tkdrawSaveFile
    $m.menu add checkbutton -label "Export as EPS" -variable tkdraw(postscript)

    $m.menu add separator
    $m.menu add cascade -label Print -menu $m.menu.print
    $m.menu add separator
    $m.menu add command -label Quit -command tkdrawQuitDlg

    menu $m.menu.print
    $m.menu.print add radiobutton -label All -variable tkdraw(printOption) -value all \
	-command tkdrawPrint
    $m.menu.print add radiobutton -label Region -variable tkdraw(printOption) -value region \
	-command tkdrawPrint

    #******* Edit ************
    set m $tkdraw(r).mbar.edit
    menubutton $m -text Edit -underline 0 -menu $m.menu
    pack $m -side left
    menu $m.menu

    $m.menu add command -label Undo      -command tkdrawUndo -state disabled
    $m.menu add separator
    $m.menu add command -label Copy      -command tkdrawCopySelected
    $m.menu add command -label Paste     -command tkdrawPaste
    $m.menu add command -label Duplicate -command tkdrawDuplicateSelected
    $m.menu add command -label Cut       -command tkdrawCutSelected
    $m.menu add command -label Delete    -command tkdrawDeleteSelected
    $m.menu add separator
    $m.menu add command -label "Flip x"  -command "tkdrawFlipxSelected"
    $m.menu add command -label "Flip y"  -command "tkdrawFlipySelected"
    $m.menu add command -label R90       -command "tkdrawRotateSelected 90"
    $m.menu add command -label R270      -command "tkdrawRotateSelected 270"
    $m.menu add command -label Scale     -command "tkdrawScaleSelectedDlg"
    $m.menu add separator
    $m.menu add command -label Command   -command tkdrawAddCommandSelected

    #******* Structure ************
    set m $tkdraw(r).mbar.struc
    menubutton $m -text Structure -underline 0 -menu $m.menu
    pack $m -side left
    menu $m.menu

    $m.menu add command -label Group   -command tkdrawGroupSelected
    $m.menu add command -label Ungroup -command tkdrawUngroupSelected
    $m.menu add separator
    $m.menu add command -label "Bring to Front" -command tkdrawRiseSelected
    $m.menu add command -label "Send to Back" -command tkdrawLowerSelected

    #******* Align ************
    set m $tkdraw(r).mbar.align
    menubutton $m -text Align -underline 0 -menu $m.menu
    pack $m -side left
    menu $m.menu


    $m.menu add command -label "Align X"   -command "tkdrawAlignSelected 1 0"
    $m.menu add command -label "Align Y"   -command "tkdrawAlignSelected 0 1"
    $m.menu add command -label "Align XY"   -command "tkdrawAlignSelected 1 1"
    $m.menu add separator
    $m.menu add command -label "Reference Alignment" -state disabled
    $m.menu add radiobutton -label Left   -variable tkdraw(refx) -value left
    $m.menu add radiobutton -label Center -variable tkdraw(refx) -value center
    $m.menu add radiobutton -label Right  -variable tkdraw(refx) -value right
    $m.menu add separator
    $m.menu add radiobutton -label Top    -variable tkdraw(refy) -value top
    $m.menu add radiobutton -label Center -variable tkdraw(refy) -value center
    $m.menu add radiobutton -label Bottom -variable tkdraw(refy) -value bottom
    $m.menu add separator
    $m.menu add command -label "Object Alignment" -state disabled
    $m.menu add radiobutton -label Left   -variable tkdraw(objx) -value left
    $m.menu add radiobutton -label Center -variable tkdraw(objx) -value center
    $m.menu add radiobutton -label Right  -variable tkdraw(objx) -value right
    $m.menu add separator
    $m.menu add radiobutton -label Top    -variable tkdraw(objy) -value top
    $m.menu add radiobutton -label Center -variable tkdraw(objy) -value center
    $m.menu add radiobutton -label Bottom -variable tkdraw(objy) -value bottom

#     $m.menu add command -label "Left"   -command "tkdrawAlignSelected left 0"
#     $m.menu add command -label "Center" -command "tkdrawAlignSelected center 0"
#     $m.menu add command -label "Right"  -command "tkdrawAlignSelected right 0"
#     $m.menu add separator
#     $m.menu add command -label "Top"      -command "tkdrawAlignSelected 0 top"
#     $m.menu add command -label "Center"   -command "tkdrawAlignSelected 0 center"
#     $m.menu add command -label "Bottom"   -command "tkdrawAlignSelected 0 bottom"
#     $m.menu add separator
#     $m.menu add command -label "Center XY"   -command "tkdrawAlignSelected center center"

    #******* Font ************
    set m $tkdraw(r).mbar.line
    menubutton $m -text Font -underline 0 -menu $m.menu
    pack $m -side left
    menu $m.menu

    $m.menu add radiobutton -label Helvetica -variable tkdraw(font) -value Helvetica
    $m.menu add radiobutton -label Times     -variable tkdraw(font) -value Times
    $m.menu add radiobutton -label Courier   -variable tkdraw(font) -value Courier
    $m.menu add separator
    $m.menu add radiobutton -label 8pt -variable tkdraw(fontsize) -value 8
    $m.menu add radiobutton -label 10pt -variable tkdraw(fontsize) -value 10
    $m.menu add radiobutton -label 12pt -variable tkdraw(fontsize) -value 12
    $m.menu add radiobutton -label 16pt -variable tkdraw(fontsize) -value 16
    $m.menu add radiobutton -label 20pt -variable tkdraw(fontsize) -value 20
    $m.menu add radiobutton -label 24pt -variable tkdraw(fontsize) -value 24
    $m.menu add radiobutton -label 30pt -variable tkdraw(fontsize) -value 30
    $m.menu add radiobutton -label 36pt -variable tkdraw(fontsize) -value 36
    $m.menu add separator
    $m.menu add radiobutton -label normal -variable tkdraw(fontstyle) -value Medium
    $m.menu add radiobutton -label bold   -variable tkdraw(fontstyle) -value Bold
    $m.menu add separator
    $m.menu add radiobutton -label left   -variable tkdraw(anchor) -value w
    $m.menu add radiobutton -label center -variable tkdraw(anchor) -value center
    $m.menu add radiobutton -label right  -variable tkdraw(anchor) -value e
#     $m.menu add separator
#     $m.menu add radiobutton -label left   -variable tkdraw(justifytext) -value left
#     $m.menu add radiobutton -label center -variable tkdraw(justifytext) -value center
#     $m.menu add radiobutton -label right  -variable tkdraw(justifytext) -value right

    #******* Brush ************
    set m $tkdraw(r).mbar.brush
    menubutton $m -text Brush -underline 0 -menu $m.menu
    pack $m -side left
    menu $m.menu

    $m.menu add radiobutton -bitmap @$tkdraw(BITMAP)/width.1.xbm -variable tkdraw(lwidth) -value 1
    $m.menu add radiobutton -bitmap @$tkdraw(BITMAP)/width.2.xbm -variable tkdraw(lwidth) -value 2
    $m.menu add radiobutton -bitmap @$tkdraw(BITMAP)/width.3.xbm -variable tkdraw(lwidth) -value 3
    $m.menu add radiobutton -bitmap @$tkdraw(BITMAP)/width.4.xbm -variable tkdraw(lwidth) -value 4
    $m.menu add separator
    $m.menu add radiobutton -bitmap @$tkdraw(BITMAP)/width.1.xbm \
	-variable tkdraw(arrow) -value none
    $m.menu add radiobutton -bitmap @$tkdraw(BITMAP)/larrow.xbm \
	-variable tkdraw(arrow) -value first
    $m.menu add radiobutton -bitmap @$tkdraw(BITMAP)/rarrow.xbm \
	-variable tkdraw(arrow) -value last
    $m.menu add radiobutton -bitmap @$tkdraw(BITMAP)/rlarrow.xbm \
	-variable tkdraw(arrow) -value both

    #******* Pattern ************
    set m $tkdraw(r).mbar.pat
    menubutton $m -text Pattern -underline 0 -menu $m.menu
    pack $m -side left
    menu $m.menu

#     set tkdraw(radioPat) $tkdraw(stipple)
    set tkdraw(radioPat) none
    $m.menu add radiobutton -label none \
	    -variable tkdraw(radioPat) -value none
    $m.menu add separator
#     $m.menu add radiobutton -bitmap @$tkdraw(BITMAP)/stipple0.xbm  \
# 	    -variable tkdraw(radioPat) -value @$tkdraw(BITMAP)/stipple0.xbm
    $m.menu add radiobutton -bitmap @$tkdraw(BITMAP)/stipple0.xbm  \
	    -variable tkdraw(radioPat) -value solid
    $m.menu add radiobutton -bitmap @$tkdraw(BITMAP)/gray50.xbm  \
	    -variable tkdraw(radioPat) -value @$tkdraw(BITMAP)/gray75.xbm
    $m.menu add radiobutton -bitmap @$tkdraw(BITMAP)/gray50.xbm  \
	    -variable tkdraw(radioPat) -value @$tkdraw(BITMAP)/gray50.xbm
    $m.menu add radiobutton -bitmap @$tkdraw(BITMAP)/gray25.xbm  \
	    -variable tkdraw(radioPat) -value @$tkdraw(BITMAP)/gray25.xbm
    $m.menu add radiobutton -bitmap @$tkdraw(BITMAP)/gray6.xbm  \
	    -variable tkdraw(radioPat) -value @$tkdraw(BITMAP)/gray6.xbm

    $m.menu add separator

    $m.menu add radiobutton -bitmap @$tkdraw(BITMAP)/stipple1.xbm  \
	    -variable tkdraw(radioPat) -value @$tkdraw(BITMAP)/stipple1.xbm
    $m.menu add radiobutton -bitmap @$tkdraw(BITMAP)/stipple2.xbm  \
	    -variable tkdraw(radioPat) -value @$tkdraw(BITMAP)/stipple2.xbm
    $m.menu add radiobutton -bitmap @$tkdraw(BITMAP)/stipple3.xbm  \
	    -variable tkdraw(radioPat) -value @$tkdraw(BITMAP)/stipple3.xbm
    $m.menu add radiobutton -bitmap @$tkdraw(BITMAP)/stipple4.xbm  \
	    -variable tkdraw(radioPat) -value @$tkdraw(BITMAP)/stipple4.xbm
    $m.menu add radiobutton -bitmap @$tkdraw(BITMAP)/stipple5.xbm  \
	    -variable tkdraw(radioPat) -value @$tkdraw(BITMAP)/stipple5.xbm
    $m.menu add radiobutton -bitmap @$tkdraw(BITMAP)/stipple6.xbm  \
	    -variable tkdraw(radioPat) -value @$tkdraw(BITMAP)/stipple6.xbm
    $m.menu add radiobutton -bitmap @$tkdraw(BITMAP)/stipple7.xbm  \
	    -variable tkdraw(radioPat) -value @$tkdraw(BITMAP)/stipple7.xbm

    #******* LineColor ************
    set m $tkdraw(r).mbar.lineCol
    menubutton $m -text LineColor -underline 0 -menu $m.menu
    pack $m -side left
    menu $m.menu

    set tkdraw(radioCol) $tkdraw(color)
    $m.menu add radiobutton -label None    -variable tkdraw(radioCol) -value none
    $m.menu add radiobutton -label Black   -variable tkdraw(radioCol) -value black
    $m.menu add radiobutton -label Blue    -variable tkdraw(radioCol) -value blue
    $m.menu add radiobutton -label Green   -variable tkdraw(radioCol) -value green
    $m.menu add radiobutton -label Red     -variable tkdraw(radioCol) -value red
    $m.menu add radiobutton -label Cyan    -variable tkdraw(radioCol) -value cyan
    $m.menu add radiobutton -label Magenta -variable tkdraw(radioCol) -value magenta
    $m.menu add radiobutton -label Yellow  -variable tkdraw(radioCol) -value yellow
    $m.menu add radiobutton -label White   -variable tkdraw(radioCol) -value white

    $m.menu add separator

    $m.menu add radiobutton -label Other  -variable tkdraw(radioCol) -value other

    #******* FgColor ************
    set m $tkdraw(r).mbar.fg
    menubutton $m -text FgColor -underline 0 -menu $m.menu
    pack $m -side left
    menu $m.menu

#     set tkdraw(radioFill) $tkdraw(fill)
    set tkdraw(radioFill) none
    $m.menu add radiobutton -label None    -variable tkdraw(radioFill) -value none
    $m.menu add radiobutton -label Black   -variable tkdraw(radioFill) -value black
    $m.menu add radiobutton -label Blue    -variable tkdraw(radioFill) -value blue
    $m.menu add radiobutton -label Green   -variable tkdraw(radioFill) -value green
    $m.menu add radiobutton -label Red     -variable tkdraw(radioFill) -value red
    $m.menu add radiobutton -label Cyan    -variable tkdraw(radioFill) -value cyan
    $m.menu add radiobutton -label Magenta -variable tkdraw(radioFill) -value magenta
    $m.menu add radiobutton -label Yellow  -variable tkdraw(radioFill) -value yellow
    $m.menu add radiobutton -label White   -variable tkdraw(radioFill) -value white

    $m.menu add separator

    $m.menu add radiobutton -label Other  -variable tkdraw(radioFill) -value other
    #******* BgColor ************
    set m $tkdraw(r).mbar.bg
    menubutton $m -text BgColor -underline 0 -menu $m.menu
    pack $m -side left
    menu $m.menu

    set tkdraw(radioBgCol) none
    $m.menu add radiobutton -label None    -variable tkdraw(radioBgCol) -value none
    $m.menu add radiobutton -label Black   -variable tkdraw(radioBgCol) -value black
    $m.menu add radiobutton -label Blue    -variable tkdraw(radioBgCol) -value blue
    $m.menu add radiobutton -label Green   -variable tkdraw(radioBgCol) -value green
    $m.menu add radiobutton -label Red     -variable tkdraw(radioBgCol) -value red
    $m.menu add radiobutton -label Cyan    -variable tkdraw(radioBgCol) -value cyan
    $m.menu add radiobutton -label Magenta -variable tkdraw(radioBgCol) -value magenta
    $m.menu add radiobutton -label Yellow  -variable tkdraw(radioBgCol) -value yellow
    $m.menu add radiobutton -label White   -variable tkdraw(radioBgCol) -value white

    
    #******* View ************
    set m $tkdraw(r).mbar.view
    menubutton $m -text View -underline 0 -menu $m.menu
    pack $m -side left
    menu $m.menu

#     $m.menu add cascade -label Hide -menu $m.menu.hide
#     menu $m.menu.hide
#     foreach i $tkdraw(layers) {
# 	$m.menu.hide add checkbutton -label "$i" -variable tkdraw_hide($i)
#     }
#     $m.menu.hide add command -label "All" -command {
# 	foreach i [array name tkdraw_hide] { set tkdraw_hide($i) 1 }
#     }
#     $m.menu.hide add command -label "None" -command {
# 	foreach i [array name tkdraw_hide] { set tkdraw_hide($i) 0 }
#     }

    $m.menu add command -label "Zoom normal" -command "tkdrawZoom 1"
    $m.menu add separator
    $m.menu add checkbutton -label "Gravity on" -variable tkdraw(gravity)
    $m.menu add checkbutton -label "Show Grid"  -variable tkdraw(showgrid)

    #******* Help ************
    set m $tkdraw(r).mbar.help
    menubutton $m -text Help -underline 0 -menu $m.menu
    pack $m -side right
    menu $m.menu

    $m.menu add command -label "Keybindings" -command tkdrawDescribeKeybindings
    $m.menu add command -label "Describe Mode" -command tkdrawDescribeEditmode
    $m.menu add separator
    $m.menu add command -label About -command tkdrawAbout
    
    #******************** CANVAS Bereich **************************

    scrollbar $tkdraw(r).hscroll -orient horiz \
	    -command "tkdrawDragXCanvas"
    scrollbar $tkdraw(r).vscroll \
	    -command "tkdrawDragYCanvas"
#     scrollbar $tkdraw(r).hscroll -orient horiz \
# 	    -command "tkdrawDragGrid; $tkdraw(c) xview"
#     scrollbar $tkdraw(r).vscroll \
# 	    -command "tkdrawDragGrid; $tkdraw(c) yview"

    pack $tkdraw(r).hscroll -side bottom -fill x
    pack $tkdraw(r).vscroll -side right -fill y

    set tkdraw(canWidth)  1000
    set tkdraw(canHeight) 1000
    canvas $tkdraw(c) -relief sunken -borderwidth 2 \
	-scrollregion "0 0 $tkdraw(canWidth) $tkdraw(canHeight)" \
	-background white \
	-xscrollcommand "$tkdraw(r).hscroll set" \
	-yscrollcommand "$tkdraw(r).vscroll set"

    pack $tkdraw(c) -expand yes -fill both

    #drawing grid
#     image create photo tdGrd -width 1000 -height 1000
    image create photo tkdrawGrid

    set tkdraw(grid) 0

    #******************** File Parsen *****************************

    trace variable tkdraw            w tkdrawUpdate
    trace variable tkdraw(color)     w tkdrawUpdateSelected
    trace variable tkdraw(bgcolor)   w tkdrawUpdateSelected
    trace variable tkdraw(fill)      w tkdrawUpdateSelected
    trace variable tkdraw(lwidth)    w tkdrawUpdateSelected
    trace variable tkdraw(arrow)     w tkdrawUpdateSelected
    trace variable tkdraw(stipple)   w tkdrawUpdateSelected
    trace variable tkdraw(font)      w tkdrawUpdateSelected
    trace variable tkdraw(fontsize)  w tkdrawUpdateSelected
    trace variable tkdraw(fontstyle) w tkdrawUpdateSelected

    trace variable tkdraw(edit)     w tkdrawPrintStatusline
    trace variable tkdraw(color)    w tkdrawPrintStatusline
    trace variable tkdraw(fill)     w tkdrawPrintStatusline
    trace variable tkdraw(lwidth)   w tkdrawPrintStatusline
    trace variable tkdraw(stipple)  w tkdrawPrintStatusline
    trace variable tkdraw(font)     w tkdrawPrintStatusline
    trace variable tkdraw(fontsize) w tkdrawPrintStatusline
    trace variable tkdraw(scaling)  w tkdrawPrintStatusline
    trace variable tkdraw(modified) w tkdrawPrintStatusline

#     puts [llength $argv]
    if { [llength $argv] >= 1 } {
	set tkdraw(filename) [lindex $argv 0]
	tkdrawOpenFile $tkdraw(filename)
    } else {
	tkdrawNewFile
    }

    foreach clipart [glob $tkdraw(CLIPART)/*.tdr] {
	set tmp [file split $clipart]
	set fname [lindex $tmp end]
	set name  [file rootname $fname] 

	tkdrawOpenClipart $name $fname
    }

    # tkdrawOpenClipart ESymb esymbole.tdr

    set tkdraw(oldedit) $tkdraw(edit)

    bind $tkdraw(c) <Enter> {
	set tkdraw(canvas) $tkdraw(c)

	#dirty quick hack to prevent interrupt of construction
	#of objects when leaving canvas
	set cvs $tkdraw(c)
	if { $tkdraw_editOld($cvs) != $tkdraw(edit) } {
	    puts "editmode changed"
	    tkdrawBindEditmode $tkdraw(edit) $tkdraw(c)
	}
    }

    tkdrawBindEditmode $tkdraw(edit) $tkdraw(c)
    tkdrawComputeFontName
}

#*********************** Print ****************************************

proc tkdrawPrint { } {
    global tkdraw

    switch $tkdraw(printOption) {
	region {
	    lappend tkdraw(regionhook) "tkdrawPrintRegion \$tkdraw(region)"
	    tkdrawBindRegion
	}
	all {
	    tkdrawPrintRegion [$tkdraw(c) bbox all]
	}
	
    }
}

proc tkdrawPrintRegion { region } {
    global tkdraw

    #temporaere Objekte wie Selectbox & Handles loeschen!
    tkdrawLeaveEditmode $tkdraw(c)
    tkdrawDeselectAll

    set x [lindex $region 0]
    set y [lindex $region 1]
    set w [expr [lindex $region 2]-$x]
    set h [expr [lindex $region 3]-$y]

    $tkdraw(c) postscript -colormode color -width $w -height $h -x $x -y $y -file tkdraw.ps
    #letzten editmode wieder herstellen
    tkdrawRestoreEditmode $tkdraw(c)
}


#************ Changed propagation / Trace-Procedures **********************

proc tkdrawUpdateSelected {VarName ElemName Operation} {
    global tkdraw

#     puts "tkdrawUpdateSelected $VarName $ElemName $Operation"

    set selected [$tkdraw(c) find withtag selected]

    if { $selected != "" } {
	switch $ElemName {
	    color {
		foreach id $selected {
		    if { ([tkdrawIsItem $id] == 1) && ([tkdrawIsBgItem $id] == 0) } {			switch -exact [$tkdraw(c) type $id] {
			    line {
				$tkdraw(c) itemconfigure $id -fill $tkdraw(color)
			    }
			    text {
				$tkdraw(c) itemconfigure $id -fill $tkdraw(color)
			    }
			    default {
				$tkdraw(c) itemconfigure $id -outline $tkdraw(color)
			    }
			}
		    }
		}
	    }
	    bgcolor {
		foreach id $selected {
		    if { [tkdrawIsBgItem $id] == 1 } {
			switch -exact [$tkdraw(c) type $id] {
			    line {
				$tkdraw(c) itemconfigure $id -fill $tkdraw(bgcolor)
			    }
			    text {
				# $tkdraw(c) itemconfigure $id -fill $tkdraw(bgcolor)
			    }
			    default {
				$tkdraw(c) itemconfigure $id -fill $tkdraw(bgcolor) \
					-outline $tkdraw(bgcolor)
			    }
			}
		    }
		}
	    }
	    fill {
		foreach id $selected {
		    if { ([tkdrawIsItem $id] == 1) && ([tkdrawIsBgItem $id] == 0) } {
			switch -exact [$tkdraw(c) type $id] {
			    line {
			    }
			    text {
			    }
			    default {
				$tkdraw(c) itemconfigure $id -fill $tkdraw(fill)
			    }
			}
		    }
		}
	    }
	    stipple {
		foreach id $selected {
		    if { ([tkdrawIsItem $id] == 1) && ([tkdrawIsBgItem $id] == 0) } {
			catch {
			    $tkdraw(c) itemconfigure $id -stipple $tkdraw(stipple)
			}
		    }
		}
	    }
	    lwidth {
		foreach id $selected {
		    switch -exact [$tkdraw(c) type $id] {
			text {
			}
			default {
			    $tkdraw(c) itemconfigure $id -width $tkdraw(lwidth)
			}
		    }
		}
	    }
	    arrow {
		foreach id $selected {
		    catch { $tkdraw(c) itemconfigure $id -arrow $tkdraw(arrow) }
		}
	    }
	    font {
		tkdrawResetFontSelected
	    }
	    fontstyle {
# 		puts "Fontstyle changed"
		tkdrawResetFontSelected
	    }
	    fontsize {
		tkdrawRescaleFontSelected
	    }
	}
    }
}

proc tkdrawUpdate {VarName ElemName Operation} {
    global tkdraw

#     puts "tkdrawUpdate $VarName $ElemName $Operation"

    switch $VarName {
	tkdraw {
	    switch -exact $ElemName {
		filename {
		    wm title . $tkdraw(filename)
		    wm iconname . [lindex [file split $tkdraw(filename)] end]
		}
		edit {
		    tkdrawLeaveEditmode $tkdraw(c)
		    tkdrawBindEditmode  $tkdraw(edit) $tkdraw(c)
		}
		raster {
		    #Rasterabhaengige Bindings aktualisieren
		    tkdrawLeaveEditmode   $tkdraw(c)
		    tkdrawBindEditmode  $tkdraw(edit) $tkdraw(c)
		    tkdrawComputeFontName

		    #grid aktualisieren
		    
		}
		gravity {
		    if { $tkdraw(gravity) } {
			set tkdraw(raster) [expr $tkdraw(rastersize)*$tkdraw(scaling)]
		    } else {
			set tkdraw(raster) 0
		    }
		}
		radioCol {
		    switch -exact $tkdraw(radioCol) {
			none  { set tkdraw(color) "" }
			other { set tkdraw(color) [tk_chooseColor] }
			default {
			    set tkdraw(color) $tkdraw(radioCol)
			}
		    }
		}
		radioBgCol {
		    switch -exact $tkdraw(radioBgCol) {
			none    { set tkdraw(bgcolor) "" }
			other   { set tkdraw(bgcolor) [tk_chooseColor] }
			default { set tkdraw(bgcolor) $tkdraw(radioBgCol) }
		    }
		}
		radioFill {
		    switch -exact $tkdraw(radioFill) {
			none {
			    set tkdraw(fill) ""
			    set tkdraw(radioBgCol) none
			}
			other {   set tkdraw(fill) [tk_chooseColor] }
			default { set tkdraw(fill) $tkdraw(radioFill) }
		    }
		}
		radioPat {
		    switch -exact $tkdraw(radioPat) {
			none  { set tkdraw(stipple) "" }
			solid { set tkdraw(stipple) "" }
			default {
			    set tkdraw(stipple) $tkdraw(radioPat)
			}
		    }
		}
		font {
		    tkdrawComputeFontName
		}
		fontstyle {
		    tkdrawComputeFontName
		}
		fontsize {
		    tkdrawComputeFontName
		}
		showgrid {
		    tkdrawRedrawGrid
		}
		undo {
		    set m $tkdraw(r).mbar.edit.menu
		    if { $tkdraw(undo) == "" } {
			 $m entryconfigure [$m index Undo] -state disabled
		    } else {
			 $m entryconfigure [$m index Undo] -state normal
		    }
		}
	    }
	}
    }
}

#*********************** Auxilary ****************************************

proc tkdrawUndo { } {
    global tkdraw

    eval $tkdraw(undo)
    set tkdraw(undo) ""
}

proc tkdrawSortLayers { } {
    global tkdraw

    foreach layer $tkdraw(layers) {
	$tkdraw(c) raise $layer
    }
}

proc tkdrawAbout {} {
    global tkdraw

#     set version [lindex [split $tkdraw(revision) " "] 1]
    set version $tkdraw(version)

    set tmp [tk_dialog .aboutdlg "About" \
		 "TKDraw\n Version $version"\
		 info 0 Ok ]
    switch $tmp {
	0 { }
    }
}
proc tkdrawQuitDlg {} {
    global tkdraw

    set tmp [tk_dialog .quitdlg "Quit" \
		 "Are you sure?" question 0 Ok Cancel]


    switch $tmp {
	0 { 
	    if { $tkdraw(modified) != 0 } {
		savedlg
	    }
	    destroy .
	}
    }
}

proc savedlg {} {
    global tkdraw

    set tmp [tk_dialog .savedlg "Save" \
		     "Save Changes in $tkdraw(filename) ?" question 0 Yes No]
    switch $tmp {
	0 { tkdrawSaveFile 1 }
    }
}


set tkdraw(message_timer) 0
set tkdraw(locked) 0
set tkdraw(modified) 0
proc tkdrawPrintStatusline {VarName ElemName Operation} {
    global tkdraw

    if { $tkdraw(message_timer) > 0 } return

    #Normale Statusausgabe
    if { $tkdraw(modified) != 0 } { set modstar "*" } else { set modstar " " }

    set tkdraw(statustext) " $modstar$tkdraw(filename)     editmode: $tkdraw(edit)"
}

proc tkdrawStatusMessage { text {duration 3000}} {
    global tkdraw

    set tkdraw(message_timer) $duration
    set tkdraw(statustext) $text

    tkdraw_decr_message_timer
}

#count_down timer fuer messages
proc tkdraw_decr_message_timer { } {
    global tkdraw

    if { $tkdraw(message_timer) > 0 } {
	incr tkdraw(message_timer) -100
	after 100 tkdraw_decr_message_timer
    } else {
	tkdrawPrintStatusline x x x
    }
}

proc min { a b } { return [expr ($a<$b) ? $a : $b] }
proc max { a b } { return [expr ($a>$b) ? $a : $b] }
proc abs { a }   { return [expr abs($a)] }

